

/* hashtabs.h */


/*------------------------------------------------------------------------
 * Module for management of the complete hash lookup tables
 *------------------------------------------------------------------------
 */


/*
 * The complete hash lookup table functions manage the calculation of the
 * HashKey and the selection of the specific hash list to store the field
 * and its statistic. The calculation of the statistic is not part of this
 * module.
 *
 * HashKey range checking is done with assert.
 */


/*----------------------------------------------------------------------*/

#ifndef HASHTABS_H
#define HASHTABS_H

/*----------------------------------------------------------------------*/

#include "mytypes.h"
#include "field.h"

/*----------------------------------------------------------------------*/


typedef struct s_HASHTABS *tpsHASHTABS;
typedef tpsHASHTABS       *tppsHASHTABS;

/*---------------------------------------------*/

tVOID       vHashTabsOpen         (tVOID);
tVOID       vHashTabsClose        (tVOID);
tVOID       vHashTabsMemEmpty     (tpCOUNT pcnSizeof, tpCOUNT pcnBlocks);

tpsHASHTABS psHashTabsCreate      (tVOID);
tpsHASHTABS psHashTabsDestroy     (tpsHASHTABS psTabs);
tpsHASHTABS psHashTabsMemUsage    (tpsHASHTABS psTabs, tpCOUNT pcnSizeof, tpCOUNT pcnBlocks);

tVOID       vHashTabsInsert       (tpsHASHTABS psTabs, tpsFIELDVAL psVal);

tVOID       vHashTabsLoopInit     (tpsHASHTABS psTabs);
tBOOL       bHashTabsLoopNext     (tpsHASHTABS psTabs, tpsFIELDVAL psVal);

tCOUNT      cnHashTabsEntriesList (tpsHASHTABS psTabs);
tCOUNT      cnHashTabsEntriesHash (tpsHASHTABS psTabs, tCOUNT cnHashKey);
tCOUNT      cnHashTabsEntriesLoop (tpsHASHTABS psTabs);


/*----------------------------------------------------------------------*/

#endif
